<?php

function efConvertBazaarMessages() {
	return array(
		'en' => array(
		'convertbazaar' => 'Convert Bazaar INI'
	), );
}

class convertbazaar extends SpecialPage {

	var $FORM_TARGET = "http://www.eqwiki.net/wiki/Special:ConvertBazaar";
	var $LF = "\n";

	var $form_bazaartext    = null;
	var $form_converttoname = null;
	var $converted_text     = null;

	var $found_itemtosell = false;

		/**
		 * Constructor
		 */
	public function __construct() {
		global $wgMessageCache;

		foreach( efConvertBazaarMessages() as $lang => $messages )
			$wgMessageCache->addMessages( $messages, $lang );

		parent::__construct( 'ConvertBazaar', 'convertbazaar' );
	}

	/**
	 * @param $par Parameters passed to the page
	 */
	public function execute( $par ) {
		global $wgUser, $wgRequest, $wgOut, $item_fields;
		$this->setHeaders();
				
			# Keep out blocked users
		if( $wgUser->isBlocked() ) {
			$wgOut->blockedPage();
			return;
		}

		$wgOut->addHTML("This page converts the old style BZR_name_server_.ini file using item names to the new style using IDs. ");
		$wgOut->addHTML("Simply paste the contents of the file below, hit convert, and copy the converted file. You can also reverse the");
		$wgOut->addHTML(" conversion by checking the <i>Convert From ID to Name</i> checkbox at the bottom.<p>");
		$wgOut->addHTML("<b>Warning:</b> Work in Progress. Always backup your original bazaar file.<p>");

		$this->parseQuery();
		if ($this->form_bazaartext) $this->convertText();
		$this->outputEditForm();

		$query = "UPDATE site_stats SET ss_eqconvertbazaar_count = ss_eqconvertbazaar_count + 1";
		mysql_query($query);
	}


	private function outputEditForm () {
		global $wgOut;

		$wgOut->addHTML("<form method='post' action='". $this->FORM_TARGET . "' >\n");

		if ($this->converted_text)
			$wgOut->addHTML("<b>Copy Converted Bazaar File Below</b> \n");
		else
			$wgOut->addHTML("<b>Paste Old Bazaar INI File Below</b> \n");

		$wgOut->addHTML("<br/>");

		$wgOut->addHTML("<textarea name='bazaartext' rows='20'>");
		$wgOut->addHTML($this->converted_text);
		$wgOut->addHTML("</textarea>");
		$wgOut->addHTML("<input type='submit' value='Convert'/>");
		$wgOut->addHTML(" &nbsp; &nbsp; &nbsp; &nbsp; <input type='checkbox' name='converttoname' value='1' ". (($this->form_converttoname != 0) ? "CHECKED" : "") ."/> <small>Convert From ID to Name</small>");
		$wgOut->addHTML("</form>\n");
	}

	private function parseQuery () {
		$this->form_bazaartext    = urldecode($_REQUEST["bazaartext"]);
		$this->form_converttoname = intval($_REQUEST["converttoname"]);
	}

	private function convertText () {
		$lines = explode($this->LF, $this->form_bazaartext);
		$this->converted_text = "";

		foreach ($lines as $index => $linetext) {
			$this->converted_text .= $this->convertLine($linetext);
		}				
	}

	private function convertLine ($linetext) {
		global $wgOut;

		$parse = explode("=", $linetext, 2);	

		if ($linetext == "[itemtosell]") {
			$this->found_itemtosell = true;
			return $linetext . $this->LF;
		}
		else if (count($parse) > 1) {
			$itemname  = $this->convertName($parse[0]);
			$itemvalue = $parse[1];

			return $itemname . "=" . $itemvalue . $this->LF;			
		}
		else {
			return $linetext . $this->LF;
		}
	}

	private function convertName ($itemname) {
		$isspellitem = preg_match("/:[0-9]+$/", $itemname);
		if ($isspellitem) return $this->convertSpell($itemname);

		return $this->convertRegularName($itemname);
	}

	private function convertRegularName ($itemname) {
		global $wgOut;

		$isnumber = is_numeric($itemname);

		if ($this->form_converttoname != 0) {
			if (!$isnumber) return $itemname;

			$query  = "SELECT name FROM eqitems WHERE id=" . intval($itemname);
			$result = mysql_query($query);
			if (!$result) return $itemname;

			$row = mysql_fetch_row($result);
			if (!$row) return $itemname;
			return $row[0];
		}

		if ($isnumber) return $itemname;

		$query  = "SELECT id FROM eqitems WHERE name='" . mysql_real_escape_string($itemname) . "' LIMIT 1";
		$result = mysql_query($query);
		if (!$result) return $itemname;

		$row = mysql_fetch_row($result);
		if (!$row) return $itemname;
		return $row[0];
	}

	private function convertSpell ($itemname) {
		global $wgOut;

		$spellparts = split(":", $itemname);
		$partcount = count($spellparts);

		if ($partcount <= 1) return $this->convertRegularName($itemname);

		$charges  = $spellparts[$partcount - 1];
		$realname = implode(":", array_slice($spellparts, 0, -1));

		$isnumber = is_numeric($realname);

		if ($this->form_converttoname != 0) {
			if (!$isnumber) return $itemname;

			$query  = "SELECT name FROM eqitems WHERE id=" . intval($realname);
			$result = mysql_query($query);
			if (!$result) return $itemname;

			$row = mysql_fetch_row($result);
			if (!$row) return $itemname;
			return $row[0]. ":" . $charges;
		}

		if ($isnumber) return $itemname;

		$query  = "SELECT id FROM eqitems WHERE name='" . mysql_real_escape_string($realname) . "' LIMIT 1";
		$result = mysql_query($query);
		if (!$result) return "x";

		$row = mysql_fetch_row($result);
		if (!$row) return "y"; 

		return $row[0] . ":" . $charges;
	}

}

?>
